#include <Dhcp.h>
#include <Dns.h>
#include <Ethernet.h>
#include <EthernetClient.h>
#include <EthernetServer.h>
#include <EthernetUdp.h>

byte mac[] = { 0xE0, 0xDC, 0xA0, 0x17, 0x2B, 0x9F };

IPAddress ip(192,168,1, 200);
IPAddress gateway(192,168,1, 150);
IPAddress subnet(255, 255, 255, 0);

// per ottenere il mac address dell'IOT2040 digitare al pronpt dei comandi di WIN10 il comando C:\>arp -a
// ip è l'indirizzo ethernet del IOT2040  che per default all'inizio è 192.168.200.1
// gateway è l'indirizzo del router o dell'Access Point a cui è collegato l'IOT2040.

EthernetServer server(4000);    // porta 4000 : esempio di porta della connessione ethernet

boolean alreadyConnected = false; // whether or not the client was connected previously
int led = 0;
int led1 = 0;
int pinD8 = 8;    // Pin uscita Q0 dell'IOT2040   --> Vedere datasheet pin D8
int pinD9 = 9;    // Pin uscita Q1 dell'IOT2040   --> Vedere datasheet pin D9



void setup() {
  // put your setup code here, to run once:
  // Impostare in setup() che viene eseguito una sola volta il pin 8 come uscita OUTPUT.
  pinMode(pinD8,OUTPUT);   
  // Impostare in setup() che viene eseguito una sola volta il pin 8 come uscita OUTPUT.
  pinMode(pinD9,OUTPUT);   
  // initialize the ethernet device
  Ethernet.begin(mac, ip, gateway, subnet);
  // start listening for clients
  server.begin();
}



void loop() {
  // put your main code here, to run repeatedly:
  EthernetClient client = server.available();
  // when the client sends the first byte, say hello:

  if (client) {

    if (!alreadyConnected) {

      // clead out the input buffer:
      client.flush();    
      client.println("Hello, client!"); // restituisce alla connessione al client il saluto.
      alreadyConnected = true;
    } 

    if (client.available() > 0) {
      // read the bytes incoming from the client:

      char thisChar = client.read();
      // echo the bytes back to the client:
      if ( thisChar == 'L' )
      {
        digitalWrite(pinD8, HIGH);
      }

      if ( thisChar == 'H' )
      {
        digitalWrite(pinD8, LOW);
      }

      if ( thisChar == 'l' )
      {
        digitalWrite(pinD9, HIGH);
      }

      if ( thisChar == 'h' )
      {
        digitalWrite(pinD9, LOW);
      }

      server.write(thisChar);
      // echo the bytes to the server as well:
    }
  } 
}




